package com.inca.npbusi.sales.bms_sales_back;

package .tmp;

import com.inca.entity.client.pub.CompanyOnClient;
import com.inca.entity.client.pub.LotOnClient;
import com.inca.gsp.service.GSPHelper;
import com.inca.np.auth.ClientUserManager;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.CommandBase;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.DBColumnDisplayInfo;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CDetailModel;
import com.inca.np.gui.mde.CMdeModel;
import com.inca.np.util.DecimalHelper;
import com.inca.np.util.SendHelper;
import com.inca.npbusi.sales.bms_sales_back.Bms_sales_back_mde;
import com.inca.pirce.tools.ExamPriceUtil;
import com.inca.pubsrv.NpbusiDBHelper;
import com.inca.pubsrv.hov.bms_lot_def_hov.Bms_lot_def_hov;
import java.awt.Frame;
import java.math.BigDecimal;
import javax.swing.SwingUtilities;

public class Bms_sales_back_detail extends CDetailModel {
  private String a;
  
  public Bms_sales_back_detail(CFrame paramCFrame, CMdeModel paramCMdeModel) {
    super(paramCFrame, "销售退货细单", paramCMdeModel);
    DBColumnDisplayInfo dBColumnDisplayInfo;
    (dBColumnDisplayInfo = getDBColumnDisplayInfo("goodsqty1")).setDbcolumn(false);
    (dBColumnDisplayInfo = getDBColumnDisplayInfo("goodsuseqty1")).setDbcolumn(false);
    (dBColumnDisplayInfo = getDBColumnDisplayInfo("total_line1")).setDbcolumn(false);
    (dBColumnDisplayInfo = getDBColumnDisplayInfo("notaxmoney1")).setDbcolumn(false);
    (dBColumnDisplayInfo = getDBColumnDisplayInfo("settleqty1")).setDbcolumn(false);
    (dBColumnDisplayInfo = getDBColumnDisplayInfo("settlemoney1")).setDbcolumn(false);
    (dBColumnDisplayInfo = getDBColumnDisplayInfo("maxbackqty")).setDbcolumn(false);
    (dBColumnDisplayInfo = getDBColumnDisplayInfo("sadtlid1")).setDbcolumn(false);
  }
  
  public String getTablename() {
    return "bms_sabk_dtl_v";
  }
  
  public String getSaveCommandString() {
    return null;
  }
  
  protected int on_checkrow(int paramInt, DBTableModel paramDBTableModel) {
    if (DecimalHelper.toDec(getItemValue(paramInt, "goodsuseqty1")).compareTo(
        new BigDecimal("0")) <= 0) {
      infoMessage("提示", "使用单位数量不可以为空和零");
      return -1;
    } 
    if (DecimalHelper.toDec(getItemValue(paramInt, "goodsqty1")).compareTo(
        new BigDecimal("0")) <= 0) {
      infoMessage("提示", "使用单位数量必须大于零");
      return -1;
    } 
    if (DecimalHelper.toDec(getItemValue(paramInt, "unitprice")).compareTo(
        new BigDecimal("0")) < 0) {
      infoMessage("提示", "退货单价不能小于零");
      return -1;
    } 
    String str1 = ((Bms_sales_back_mde)this.mdemodel).getApvalue("是否必须勾原单");
    String str2 = getItemValue(paramInt, "sadtlid1");
    if (str1.equals("1") && ("".equals(str2) || str2 == null)) {
      infoMessage("提示", "必须勾原单生成销退！");
      return -1;
    } 
    if (!"".equals(getItemValue(paramInt, "sadtlid1"))) {
      str1 = getItemValue(paramInt, "goodsuseqty1");
      if ("".equals(str1)) {
        errorMessage("错误", "使用单位数量不能为空!");
        return -1;
      } 
      str2 = getItemValue(paramInt, "goodsuseunit");
      if ("".equals(str2)) {
        errorMessage("错误", "使用单位不能为空!");
        return -1;
      } 
      String str = getItemValue(paramInt, "goodsqty1");
      str1 = getItemValue(paramInt, "maxbackqty");
      if (DecimalHelper.toDec(str).compareTo(
          DecimalHelper.toDec(str1)) > 0) {
        infoMessage("提示", "退货数量不能大于可退数量");
        return -1;
      } 
    } 
    if ((str1 = getItemValue(paramInt, "posid")) != null && !str1.equals("") && !str1.equals("0")) {
      DBTableModel dBTableModel;
      str2 = null;
      RemotesqlHelper remotesqlHelper = new RemotesqlHelper();
      str1 = "select * from bms_storer_pos where posid = " + str1;
      try {
        dBTableModel = remotesqlHelper.doSelect(str1, 0, 1);
      } catch (Exception exception) {
        (str1 = null).printStackTrace();
      } 
      if (dBTableModel.getRowCount() <= 0)
        return -1; 
      str1 = dBTableModel.getItemValue(0, "goodsunitflag");
      if ("1".equals(str1)) {
        str1 = getItemValue(paramInt, "goodsqty");
        String str = getItemValue(paramInt, "packsize");
        if (DecimalHelper.toDec(str1)
          .remainder(DecimalHelper.toDec(str))
          .compareTo(new BigDecimal("0")) != 0) {
          infoMessage("提示", "第" + (paramInt + 1) + 
              "行细单，整件货位的数量必须是整件！");
          return -1;
        } 
      } 
    } 
    str2 = getItemValue(paramInt, "batchflag");
    String str3;
    if ("1".equals(str2) && ((
      
      str3 = getItemValue(paramInt, "batchprice")) == null || "".equals(str3))) {
      infoMessage("提示", "制定批次价，数据项【含税批次价】必填！");
      return -1;
    } 
    return super.on_checkrow(paramInt, paramDBTableModel);
  }
  
  protected int on_new(int paramInt) {
    setItemValue(paramInt, "settleflag", "0");
    setItemValue(paramInt, "stioflag", "0");
    setItemValue(paramInt, "skioflag", "0");
    setItemValue(paramInt, "saoutflag", "0");
    setItemValue(paramInt, "correctflag", "0");
    setItemValue(paramInt, "goodsstatus", (
        (Bms_sales_back_mde)this.mdemodel).getApvalue("缺省货品状态"));
    return super.on_new(paramInt);
  }
  
  protected void on_itemvaluechange(int paramInt, String paramString1, String paramString2) {
    if ("lotno".equals(paramString1)) {
      String str6 = getItemValue(paramInt, "goodsid");
      if (paramString2 == null || "".equals(paramString2) || paramString2.length() == 0) {
        setItemValue(paramInt, "lotid", "");
        setItemValue(paramInt, "proddate", "");
        setItemValue(paramInt, "lotinvaliddate", "");
        setItemValue(paramInt, "approvedocno", "");
        setItemValue(paramInt, "killlotno", "");
        setItemValue(paramInt, "killdate", "");
        setItemValue(paramInt, "printset", "");
        setItemValue(paramInt, "checkno", "");
        setItemValue(paramInt, "synchronizedapprovetogoods", "");
        super.on_itemvaluechange(paramInt, paramString1, paramString2);
        return;
      } 
      if (str6 == null || "".equals(str6)) {
        infoMessage("提示", "请先选择货品");
        setItemValue(paramInt, "lotno", "");
        super.on_itemvaluechange(paramInt, paramString1, paramString2);
        return;
      } 
      String str7 = getBatchNoCount(paramString2);
      setItemValue(paramInt, "lotid", "");
      setItemValue(paramInt, "proddate", "");
      setItemValue(paramInt, "invaliddate", "");
      setItemValue(paramInt, "approvedocno", "");
      setItemValue(paramInt, "killlotno", "");
      setItemValue(paramInt, "killdate", "");
      setItemValue(paramInt, "printset", "");
      setItemValue(paramInt, "checkno", "");
      setItemValue(paramInt, "synchronizedapprovetogoods", "");
      if ("0".equals(str7)) {
        LotOnClient lotOnClient;
        (lotOnClient = new LotOnClient(null, paramString2, str6)).autoGenProdAndInvalidDate();
        setItemValue(paramInt, "proddate", lotOnClient.getProdDate());
        setItemValue(paramInt, "invaliddate", lotOnClient.getInvalidDate());
        setItemValue(paramInt, "killdate", NpbusiDBHelper.getSysdate());
        setItemValue(paramInt, "lotid", "");
      } else {
        Bms_lot_def_hov bms_lot_def_hov = new Bms_lot_def_hov();
        String str = null;
        if (paramString2 == null || paramString2.trim().isEmpty()) {
          str = " and trim(lotno) is null";
        } else {
          str = " and lotno like '" + paramString2 + "'";
        } 
        DBTableModel dBTableModel;
        if ((dBTableModel = bms_lot_def_hov.showDialog((Frame)this.frame, "选择批号", "", "", "goodsid = " + str6 + str)) == null) {
          setFocus("lotno");
          return;
        } 
        setItemValue(paramInt, "lotno", dBTableModel.getItemValue(0, "lotno"));
        setItemValue(paramInt, "lotid", dBTableModel.getItemValue(0, "lotid"));
        setItemValue(paramInt, "invaliddate", 
            dBTableModel.getItemValue(0, "invaliddate"));
        setItemValue(paramInt, "proddate", 
            dBTableModel.getItemValue(0, "proddate"));
        setItemValue(paramInt, "approvedocno", 
            dBTableModel.getItemValue(0, "approvedocno"));
        setItemValue(paramInt, "checkno", 
            dBTableModel.getItemValue(0, "checkno"));
        setItemValue(paramInt, "killdate", 
            dBTableModel.getItemValue(0, "killdate"));
        setItemValue(paramInt, "killlotno", 
            dBTableModel.getItemValue(0, "killlotno"));
        setItemValue(paramInt, "printset", 
            dBTableModel.getItemValue(0, "printset"));
      } 
    } 
    String str1 = ClientUserManager.getCurrentUser().getEntryid();
    String str2 = this.mdemodel.getMasterModel().getItemValue(
        this.mdemodel.getMasterModel().getRow(), "entryid");
    String str3 = this.mdemodel.getMasterModel().getItemValue(
        this.mdemodel.getMasterModel().getRow(), "salesdeptid");
    String str4 = null;
    str4 = null;
    String str5 = null;
    if ("goodsid".equals(paramString1) && !"".equals(paramString2) && (
      this.a == null || !paramString2.equals(this.a))) {
      this.a = paramString2;
      setItemValue(paramInt, "batchid", "");
      setItemValue(paramInt, "batchno", "");
      str5 = "";
      String str7 = "";
      DBTableModel dBTableModel = null;
      str4 = "select price from pub_price_type a,bms_entry_goods_price b where a.priceid=b.priceid and a.wholeresaleflag=1 and b.goodsid=" + 



        
        paramString2 + " and b.entryid=" + str1;
      RemotesqlHelper remotesqlHelper = new RemotesqlHelper();
      try {
        dBTableModel = remotesqlHelper.doSelect(str4, 0, 1);
      } catch (Exception exception1) {
        (str4 = null).printStackTrace();
      } 
      if (dBTableModel != null && dBTableModel.getRowCount() > 0)
        str5 = dBTableModel.getItemValue(0, "price"); 
      str4 = "select price from pub_price_type a,bms_entry_goods_price b where a.priceid=b.priceid and a.wholeresaleflag=13 and b.goodsid=" + 






        
        paramString2 + " and b.entryid=" + str1;
      try {
        dBTableModel = remotesqlHelper.doSelect(str4, 0, 1);
      } catch (Exception exception1) {
        (str4 = null).printStackTrace();
      } 
      if (dBTableModel != null && dBTableModel.getRowCount() > 0)
        str7 = dBTableModel.getItemValue(0, "price"); 
      setItemValue(paramInt, "wholesaleprice", str5);
      setItemValue(paramInt, "resaleprice", str7);
      try {
        if (!"".equals(getItemValue(paramInt, "salesdtlid")))
          return; 
        str4 = 
          ExamPriceUtil.getExamPrice(ExamPriceUtil.BMS, str2, str3, 
            getItemValue(paramInt, "goodsid"));
        str5 = ExamPriceUtil.getExamProfit(
            getItemValue(paramInt, "goodqty1"), 
            getItemValue(paramInt, "unitprice"), str4);
      } catch (Exception exception) {
        errorMessage("错误", "获取考核价失败");
        exception.printStackTrace();
        return;
      } 
      setItemValue(paramInt, "examprice", (String)exception);
      setItemValue(paramInt, "examprofit", str5);
      commitEdit();
      super.on_itemvaluechange(paramInt, paramString1, paramString2);
      String str6 = getItemValue(getRow(), "goodsunit");
      setItemValue(getRow(), "goodsuseunit", str6);
      return;
    } 
    if ("goodsuseqty1".equals(paramString1) && !"".equals(paramString2)) {
      String str6;
      if ((str5 = getItemValue(paramInt, "goodsuseunit")).indexOf("(") == -1) {
        str6 = "1";
      } else {
        str6 = str5.substring(
            str5.indexOf("(") + 1, 
            str5.indexOf(")"));
      } 
      String str7 = DecimalHelper.multi(paramString2, str6, 6);
      setItemValue(paramInt, "goodsqty1", str7);
      setItemValue(paramInt, "goodsqty", 
          DecimalHelper.multi("-1", str7, 6));
      setItemValue(paramInt, "goodsuseqty", DecimalHelper.multi(paramString2, "-1", 6));
      a(paramInt);
      str5 = ExamPriceUtil.getExamProfit(
          getItemValue(paramInt, "goodsqty1"), 
          getItemValue(paramInt, "unitprice"), 
          getItemValue(paramInt, "examprice"));
      setItemValue(paramInt, "examprofit", str5);
    } else if ("goodsuseqty1".equals(paramString1) && "".equals(paramString2)) {
      setItemValue(paramInt, "goodsqty1", "0");
      setItemValue(paramInt, "goodsqty", "0");
      a(paramInt);
    } else if ("goodsuseunit".equals(paramString1) && !"".equals(paramString2)) {
      String str6;
      str5 = getItemValue(paramInt, "goodsuseqty1");
      if (paramString2.indexOf("(") == -1) {
        str6 = "1";
      } else {
        str6 = paramString2.substring(paramString2.indexOf("(") + 1, 
            paramString2.indexOf(")"));
      } 
      String str7 = DecimalHelper.multi(str5, str6, 6);
      setItemValue(paramInt, "goodsqty1", str7);
      setItemValue(paramInt, "goodsqty", 
          DecimalHelper.multi("-1", str7, 6));
      a(paramInt);
      str5 = ExamPriceUtil.getExamProfit(
          getItemValue(paramInt, "goodsqty1"), 
          getItemValue(paramInt, "unitprice"), 
          getItemValue(paramInt, "examprice"));
      setItemValue(paramInt, "examprofit", str5);
    } else if (paramString1.equals("unitprice")) {
      a(paramInt);
      str5 = ExamPriceUtil.getExamProfit(
          getItemValue(paramInt, "goodsqty1"), 
          getItemValue(paramInt, "unitprice"), 
          getItemValue(paramInt, "examprice"));
      setItemValue(paramInt, "examprofit", str5);
    } else if ("sadtlid1".equals(paramString1) && !"".equals(paramString2)) {
      DBTableModel dBTableModel;
      str5 = null;
      String str = " select a.batchid,a.lotid,a.posid,a.goodsstatusid from bms_st_io_dtl a,bms_st_io_doc b where a.inoutid = b.inoutid and b.sourcetable = 2 and b.sourceid =" + 

        
        paramString2 + " ";
      RemotesqlHelper remotesqlHelper = new RemotesqlHelper();
      try {
        dBTableModel = remotesqlHelper.doSelect(str, 0, 1);
      } catch (Exception exception) {
        (str4 = null).printStackTrace();
      } 
      if (dBTableModel != null && dBTableModel.getRowCount() > 0) {
        setItemValue(paramInt, "batchid", 
            dBTableModel.getItemValue(0, "batchid"));
        setItemValue(paramInt, "posid", dBTableModel.getItemValue(0, "posid"));
        setItemValue(paramInt, "goodsstatusid", 
            dBTableModel.getItemValue(0, "goodsstatusid"));
        setItemValue(paramInt, "lotid", dBTableModel.getItemValue(0, "lotid"));
      } 
    } else if ("settleqty1".equals(paramString1)) {
      str5 = getItemValue(paramInt, "settleqty1");
      setItemValue(paramInt, "settleqty", 
          DecimalHelper.multi("-1", str5, 6));
    } else if ("settlemoney1".equals(paramString1)) {
      str5 = getItemValue(paramInt, "settlemoney1");
      setItemValue(paramInt, "settlemoney", 
          DecimalHelper.multi("-1", str5, 2));
    } else if ("storageid".equals(paramString1)) {
      setItemValue(paramInt, "posno", "");
    } else if ("batchid".equals(paramString1) && !"".equals(paramString2)) {
      try {
        str4 = getItemValue(paramInt, "batchid");
        str5 = "select p.wholeresaleflag from pub_price_type p,bms_examine_prtype_def e  where p.priceid = e.exampriceid  and e.companyid = " + 

          
          str3;
        RemotesqlHelper remotesqlHelper;
        DBTableModel dBTableModel;
        if ((dBTableModel = (remotesqlHelper = new RemotesqlHelper()).doSelect(str5, 0, 1)) == null || dBTableModel.getRowCount() == 0)
          return; 
        if ("9".equals(dBTableModel.getItemValue(0, "wholeresaleflag")) && 
          !"1".equals(getItemValue(paramInt, "batchflag"))) {
          str4 = "select b.unitprice from bms_batch_def b where b.batchid = " + 
            str4;
          System.err.println("batchSql-" + str4);
          if ((dBTableModel = remotesqlHelper.doSelect(str4, 0, 1)) != null && dBTableModel.getRowCount() != 0) {
            str4 = dBTableModel.getItemValue(0, "unitprice");
            setItemValue(paramInt, "examprice", str4);
            str5 = ExamPriceUtil.getExamProfit(
                getItemValue(paramInt, "goodsqty1"), 
                getItemValue(paramInt, "unitprice"), 
                getItemValue(paramInt, "examprice"));
            setItemValue(paramInt, "examprofit", str5);
          } 
        } 
      } catch (Exception exception) {
        errorMessage("错误", "获取考核价失败");
        exception.printStackTrace();
        return;
      } 
    } else if ("batchflag".equals(paramString1)) {
      if ("1".equals(getItemValue(0, "batchflag")))
        try {
          getItemValue(paramInt, "batchid");
          str5 = "select p.wholeresaleflag from pub_price_type p,bms_examine_prtype_def e  where p.priceid = e.exampriceid  and e.companyid = " + 

            
            str3;
          RemotesqlHelper remotesqlHelper;
          DBTableModel dBTableModel;
          if ((dBTableModel = (remotesqlHelper = new RemotesqlHelper()).doSelect(str5, 0, 1)) == null || dBTableModel.getRowCount() == 0)
            return; 
          if ("9".equals(dBTableModel.getItemValue(0, "wholeresaleflag"))) {
            str4 = getItemValue(paramInt, "batchprice");
            str5 = ExamPriceUtil.getExamProfit(
                getItemValue(paramInt, "goodsqty1"), 
                getItemValue(paramInt, "unitprice"), str4);
            setItemValue(paramInt, "examprice", str4);
            setItemValue(paramInt, "examprofit", str5);
          } 
        } catch (Exception exception) {
          errorMessage("错误", "获取考核价失败");
          exception.printStackTrace();
          return;
        }  
      if ("0".equals(getItemValue(0, "batchflag")))
        on_itemvaluechange(paramInt, "batchid", 
            getItemValue(paramInt, "batchid")); 
    } else if ("batchprice".equals(paramString1) && !"".equals(paramString2) && 
      "1".equals(getItemValue(0, "batchflag"))) {
      try {
        getItemValue(paramInt, "batchid");
        str5 = "select p.wholeresaleflag from pub_price_type p,bms_examine_prtype_def e  where p.priceid = e.exampriceid  and e.companyid = " + 

          
          str3;
        RemotesqlHelper remotesqlHelper;
        DBTableModel dBTableModel;
        if ((dBTableModel = (remotesqlHelper = new RemotesqlHelper()).doSelect(str5, 0, 1)) == null || dBTableModel.getRowCount() == 0)
          return; 
        if ("9".equals(dBTableModel.getItemValue(0, "wholeresaleflag"))) {
          str4 = getItemValue(paramInt, "batchprice");
          setItemValue(paramInt, "examprice", str4);
          str5 = ExamPriceUtil.getExamProfit(
              getItemValue(paramInt, "goodsqty1"), 
              getItemValue(paramInt, "unitprice"), 
              getItemValue(paramInt, "examprice"));
          setItemValue(paramInt, "examprofit", str5);
        } 
      } catch (Exception exception) {
        errorMessage("错误", "获取考核价失败");
        exception.printStackTrace();
        return;
      } 
    } 
    super.on_itemvaluechange(paramInt, paramString1, paramString2);
  }
  
  public boolean canInvokehov(String paramString) {
    if ("batchno".equals(paramString)) {
      String str = getItemValue(getRow(), "goodsid");
      System.err.print(str);
      if (str == null || "".equals(str)) {
        infoMessage("提示", "请先选择货品再选择批号");
        return false;
      } 
    } 
    if (paramString.equals("lotno")) {
      String str;
      if ((str = getItemValue(this.mdemodel.getDetailModel().getRow(), "goodsid")) == null || str.equals(""))
        return false; 
    } 
    if (paramString.equals("posno")) {
      String str;
      if ((str = getItemValue(this.mdemodel.getDetailModel().getRow(), "storageid")) == null || str.equals(""))
        return false; 
    } 
    return super.canInvokehov(paramString);
  }
  
  public int on_hov(int paramInt, String paramString, DBTableModel paramDBTableModel) {
    super.on_hov(paramInt, paramString, paramDBTableModel);
    RemotesqlHelper remotesqlHelper = null;
    remotesqlHelper = new RemotesqlHelper();
    if (paramString.equals("opcode")) {
      String str1 = paramDBTableModel.getItemValue(0, "goodsid");
      String str2 = this.mdemodel.getMasterModel().getItemValue(
          this.mdemodel.getMasterModel().getRow(), "customid");
      String str3 = ClientUserManager.getCurrentUser().getEntryid();
      str1 = "select * from bms_sa_goods_price_v a,PUB_COMPANY_TO_definfo_v b  where  (a.customid is null or a.customid =" + 
        str2 + 
        ")  and a.goodsid =" + 
        str1 + 
        
        "and a.entryid=" + 
        str3 + 
        " and a.priceid=b.priceid(+) and b.companyid=" + str2;
      try {
        DBTableModel dBTableModel;
        if ((dBTableModel = remotesqlHelper.doSelect(str1, 0, 1)) == null || dBTableModel.getRowCount() <= 0) {
          setItemValue(getRow(), "priceopcode", "");
          setItemValue(getRow(), "pricename", "");
          setItemValue(getRow(), "unitprice", "");
          setItemValue(getRow(), "priceid", "");
          infoMessage("提示", "货品没有定义默认价格，请先定义价格。");
        } else {
          setItemValue(getRow(), "priceopcode", 
              dBTableModel.getItemValue(0, "priceopcode"));
          setItemValue(getRow(), "pricename", 
              dBTableModel.getItemValue(0, "pricename"));
          setItemValue(getRow(), "unitprice", 
              dBTableModel.getItemValue(0, "price"));
          setItemValue(getRow(), "priceid", 
              dBTableModel.getItemValue(0, "priceid"));
        } 
      } catch (Exception exception) {
        (remotesqlHelper = null).printStackTrace();
      } 
      setItemValue(paramInt, "lotno", "");
      setItemValue(paramInt, "lotid", "");
      setItemValue(paramInt, "invaliddate", "");
    } 
    return super.on_hov(paramInt, paramString, paramDBTableModel);
  }
  
  private String a() {
    int i = this.mdemodel.getMasterModel().getRow();
    String str2 = ((Bms_sales_back_mde)this.mdemodel).getEntryid();
    String str1 = this.mdemodel.getMasterModel().getItemValue(i, 
        "customid");
    CompanyOnClient companyOnClient;
    (companyOnClient = new CompanyOnClient(str1)).setCompanyType(2);
    String str3 = " and " + 
      GSPHelper.getGoodsOtherWheresOnHov(str2, 
        "pub_goods_dtl_hov_v", "goodsid", true, false);
    try {
      str3 = String.valueOf(str3) + companyOnClient.sendLimitCheck("3", 
          str2);
    } catch (Exception exception) {
      errorMessage("获取供应商经营范围、类别时错误", exception.getMessage());
      return "";
    } 
    return str3;
  }
  
  public String getHovOtherWheres(int paramInt, String paramString) {
    String str;
    if ("opcode".equals(paramString)) {
      paramString = a();
      return paramString = "nvl(accflag,0)<>5 " + paramString;
    } 
    if ("batchno".equals(paramString))
      return " goodsid = " + getItemValue(paramInt, "goodsid"); 
    if (paramString.equals("lotno")) {
      if ((paramString = getItemValue(paramInt, "goodsid")) == null || paramString.equals("")) {
        infoMessage("提示", "请先录入货品!");
        return "1=2";
      } 
      return "goodsid=" + paramString;
    } 
    if (paramString.equals("posno")) {
      paramString = getItemValue(paramInt, "storageid");
      return "sthouseid in (select sthouseid from bms_st_storehouse where storerid=(select  phystoreid from bms_st_def where storageid=" + 
        
        paramString + "))";
    } 
    if (paramString.equals("priceopcode")) {
      paramString = this.mdemodel.getMasterModel().getItemValue(
          this.mdemodel.getMasterModel().getRow(), "customid");
      str = getItemValue(paramInt, "goodsid");
      return "(customid is null or customid = " + paramString + 
        ") and goodsid = " + str + " and entryid=" + (
        (Bms_sales_back_mde)this.mdemodel).getEntryid();
    } 
    if ("storageopcode".equals(paramString)) {
      str = ((Bms_sales_back_mde)this.mdemodel).getEntryid();
      return paramString = " procflag = 2 and  exists (select storageid from bms_st_def where entryid =  " + str + " and  bms_st_def.storageid=bms_st_def_v.storageid ) ";
    } 
    if ("".equals(paramString)) {
      paramString = getItemValue(getRow(), "goodsid");
      str = getItemValue(getRow(), "goodsdtlid");
      return "(goodsid=" + paramString + " and goodsdtlid=" + str + 
        ") or batchid = 0";
    } 
    return super.getHovOtherWheres(str, paramString);
  }
  
  private void a(int paramInt) {
    String str1 = this.mdemodel.getMasterModel().getItemValue(
        this.mdemodel.getMasterModel().getRow(), "exchange");
    String str2 = getItemValue(paramInt, "unitprice");
    String str3 = getItemValue(paramInt, "goodsqty1");
    String str4 = getItemValue(paramInt, "taxrate");
    if (!str1.equals("") && !str1.equals("0") && 
      !str1.equals("0.0000"))
      str2 = DecimalHelper.multi(str2, str1, 10); 
    str2 = DecimalHelper.divide(str1 = DecimalHelper.multi(str2, str3, 2), 
        DecimalHelper.add("1", str4, 10), 2);
    setItemValue(paramInt, "total_line1", str1);
    setItemValue(paramInt, "total_line", 
        DecimalHelper.multi("-1", str1, 2));
    setItemValue(paramInt, "notaxmoney1", str2);
    setItemValue(paramInt, "notaxmoney", 
        DecimalHelper.multi("-1", str2, 2));
  }
  
  public void gensabackdtl(int[] paramArrayOfint, DBTableModel paramDBTableModel) {
    DBTableModel dBTableModel = getDBtableModel();
    int i = paramArrayOfint.length;
    for (byte b = 0; b < i; b++) {
      String str = paramDBTableModel.getItemValue(paramArrayOfint[b], "salesid");
      if ((str = a(str)) != null && str.length() > 0)
        infoMessage("提示", "原销售总单附带赠品信息如下：\n" + str); 
      str = DecimalHelper.sub(
          paramDBTableModel.getItemValue(paramArrayOfint[b], "goodsqty"), 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "backQty"), 6);
      int j = dBTableModel.getRowCount();
      dBTableModel.appendRow();
      dBTableModel.setItemValue(j, "storagename", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "storagename"));
      dBTableModel.setItemValue(j, "opcode", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "opcode"));
      dBTableModel.setItemValue(j, "goodsno", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "goodsno"));
      dBTableModel.setItemValue(j, "goodsname", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "goodsname"));
      dBTableModel.setItemValue(j, "currencyname", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "currencyname"));
      dBTableModel.setItemValue(j, "goodsunit", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "goodsunit"));
      dBTableModel.setItemValue(j, "goodsuseunit", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "goodsunit"));
      dBTableModel.setItemValue(j, "goodstype", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "goodstype"));
      dBTableModel.setItemValue(j, "prodarea", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "prodarea"));
      dBTableModel.setItemValue(j, "factoryname", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "factoryname"));
      dBTableModel.setItemValue(j, "packname", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "packname"));
      dBTableModel.setItemValue(j, "packsize", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "packsize"));
      dBTableModel.setItemValue(j, "taxrate", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "taxrate"));
      dBTableModel.setItemValue(j, "maxbackqty", str);
      dBTableModel.setItemValue(j, "goodsqty1", str);
      dBTableModel.setItemValue(j, "goodsqty", 
          DecimalHelper.multi(str, "-1", 6));
      dBTableModel.setItemValue(j, "goodsuseunit", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "goodsuseunit"));
      dBTableModel.setItemValue(j, "goodsuseqty1", str);
      dBTableModel.setItemValue(j, "goodsuseqty", 
          DecimalHelper.multi(str, "-1", 6));
      dBTableModel.setItemValue(j, "priceopcode", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "priceopcode"));
      dBTableModel.setItemValue(j, "pricename", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "pricename"));
      dBTableModel.setItemValue(j, "unitprice", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "unitprice"));
      dBTableModel.setItemValue(j, "total_line1", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "total_line"));
      dBTableModel.setItemValue(j, "total_line", DecimalHelper.multi(
            paramDBTableModel.getItemValue(paramArrayOfint[b], "total_line"), "-1", 2));
      dBTableModel.setItemValue(j, "discount", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "discount"));
      dBTableModel.setItemValue(j, "notaxmoney1", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "notaxmoney"));
      dBTableModel.setItemValue(j, "notaxmoney", DecimalHelper.multi(
            paramDBTableModel.getItemValue(paramArrayOfint[b], "notaxmoney"), "-1", 2));
      dBTableModel.setItemValue(j, "timepricename", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "timepricename"));
      dBTableModel.setItemValue(j, "timeprice", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "timeprice"));
      dBTableModel.setItemValue(j, "wholesaleprice", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "wholesaleprice"));
      dBTableModel.setItemValue(j, "resaleprice", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "resaleprice"));
      dBTableModel.setItemValue(j, "lastpricename", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "lastpricename"));
      dBTableModel.setItemValue(j, "lastunitprice", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "lastunitprice"));
      dBTableModel.setItemValue(j, "allowbackflag", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "allowbackflag"));
      dBTableModel.setItemValue(j, "batchno", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "batchno"));
      dBTableModel.setItemValue(j, "lotno", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "lotno"));
      dBTableModel.setItemValue(j, "invaliddate", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "invaliddate"));
      dBTableModel.setItemValue(j, "posno", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "posno"));
      dBTableModel.setItemValue(j, "goodsstatusid", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "goodsstatusid"));
      dBTableModel.setItemValue(j, "dtlmemo", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "dtlmemo"));
      dBTableModel.setItemValue(j, "correctflag", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "correctflag"));
      dBTableModel.setItemValue(j, "stioflag", "0");
      dBTableModel.setItemValue(j, "lowerflag", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "lowerflag"));
      dBTableModel.setItemValue(j, "settleflag", "0");
      dBTableModel.setItemValue(j, "sadtlid1", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "salesdtlid"));
      dBTableModel.setItemValue(j, "goodsid", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "goodsid"));
      this.a = paramDBTableModel.getItemValue(paramArrayOfint[b], "goodsid");
      dBTableModel.setItemValue(j, "factoryid", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "factoryid"));
      dBTableModel.setItemValue(j, "goodsdtlid", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "goodsdtlid"));
      dBTableModel.setItemValue(j, "priceid", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "priceid"));
      dBTableModel.setItemValue(j, "timepriceid", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "timepriceid"));
      dBTableModel.setItemValue(j, "storageid", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "storageid"));
      dBTableModel.setItemValue(j, "storageopcode", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "storageopcode"));
      dBTableModel.setItemValue(j, "lastpriceid", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "lastpriceid"));
      dBTableModel.setItemValue(j, "batchid", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "batchid"));
      dBTableModel.setItemValue(j, "lotid", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "lotid"));
      dBTableModel.setItemValue(j, "posid", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "posid"));
      dBTableModel.setItemValue(j, "oldsadate", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "credate"));
      dBTableModel.setItemValue(j, "oldsaqty", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "goodsqty"));
      dBTableModel.setItemValue(j, "examprice", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "examprice"));
      dBTableModel.setItemValue(j, "examprofit", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "examprofit"));
      on_itemvaluechange(j, "sadtlid1", 
          paramDBTableModel.getItemValue(paramArrayOfint[b], "salesdtlid"));
    } 
    tableChanged();
  }
  
  private String a(String paramString) {
    ClientRequest clientRequest;
    (clientRequest = new ClientRequest()).addCommand((CommandBase)new StringCommand("销售退货单管理.查询原销售单赠品信息"));
    clientRequest.addCommand((CommandBase)new StringCommand(paramString));
    StringCommand stringCommand = null;
    try {
      ServerResponse serverResponse;
      if ((stringCommand = (StringCommand)(serverResponse = SendHelper.sendRequest(clientRequest)).commandAt(0)).getString().startsWith("+OK")) {
        String str;
        return str = ((StringCommand)serverResponse.commandAt(1)).getString();
      } 
      infoMessage("提示", "查询原销售单赠品信息时出错:" + stringCommand.getString());
      return null;
    } catch (Exception exception) {
      (paramString = null).printStackTrace();
      infoMessage("提示", "查询原销售单赠品信息时出错:" + paramString.getMessage());
      return null;
    } 
  }
  
  protected String getBatchNoCount(String paramString) {
    int i = this.mdemodel.getDetailModel().getRow();
    String str1 = this.mdemodel.getDetailModel().getItemValue(i, 
        "goodsid");
    String str2 = "";
    DBTableModel dBTableModel = null;
    str1 = "select count(1) from bms_lot_def where goodsid=" + str1;
    if (paramString == null || paramString.trim().isEmpty()) {
      paramString = " and trim(lotno) is null";
    } else {
      paramString = " and lotno like '" + paramString + "'";
    } 
    str1 = String.valueOf(str1) + paramString;
    RemotesqlHelper remotesqlHelper = new RemotesqlHelper();
    try {
      dBTableModel = remotesqlHelper.doSelect(str1, 0, 1);
    } catch (Exception exception) {
      (remotesqlHelper = null).printStackTrace();
    } 
    if (dBTableModel != null && dBTableModel.getRowCount() > 0)
      str2 = dBTableModel.getItemValue(0, 0); 
    return str2;
  }
  
  protected String getEditablecolumns(int paramInt) {
    String str1;
    int i = this.mdemodel.getMasterModel().getRow();
    String str2 = this.mdemodel.getMasterModel().getItemValue(i, "usestatus");
    if ("1".equals(str2))
      return ""; 
    if (getRowCount() > 0 && paramInt < getRowCount()) {
      str2 = getItemValue(paramInt, "sadtlid1");
      if (!"".equals(str2)) {
        if ((str1 = getItemValue(paramInt, "batchid")) == null || "".equals(str1))
          return "storageopcode,goodsuseqty1,goodsuseunit,backwhyid,batchflag,batchprice"; 
        return "storageopcode,goodsuseqty1,goodsuseunit,backwhyid";
      } 
      if ((str1 = this.mdemodel.getDetailModel().getItemValue(str1, "lotid")) != null && !"".equals(str1))
        return "storageopcode,opcode,priceopcode,unitprice,goodsuseunit,goodsuseqty1,backwhyid,lotno,batchno,batchflag,batchprice,posno,goodsstatusid,dtlmemo"; 
      str1 = ((Bms_sales_back_mde)this.mdemodel).getApvalue("禁止生成新批号");
      if ("1".equals(str1))
        return "storageopcode,opcode,priceopcode,unitprice,goodsuseunit,goodsuseqty1,backwhyid,lotno,batchno,batchflag,batchprice,posno,goodsstatusid,dtlmemo"; 
      return "storageopcode,opcode,priceopcode,unitprice,goodsuseunit,goodsuseqty1,backwhyid,lotno,batchno,batchflag,batchprice,posno,goodsstatusid,dtlmemo,proddate,invaliddate,checkno,approvedocno,killlotno,killdate,printset,synchronizedapprovetogoods";
    } 
    return super.getEditablecolumns(str1);
  }
  
  protected void on_retrieved() {
    int i = getRowCount();
    for (byte b = 0; b < i; b++) {
      String str = getItemValue(b, "goodsqty");
      setItemValue(b, "goodsqty1", 
          DecimalHelper.multi("-1", str, 6));
      str = getItemValue(b, "goodsuseqty");
      setItemValue(b, "goodsuseqty1", 
          DecimalHelper.multi("-1", str, 6));
      str = getItemValue(b, "total_line");
      setItemValue(b, "total_line1", 
          DecimalHelper.multi("-1", str, 2));
      str = getItemValue(b, "notaxmoney");
      setItemValue(b, "notaxmoney1", 
          DecimalHelper.multi("-1", str, 2));
      str = getItemValue(b, "settleqty");
      setItemValue(b, "settleqty1", 
          DecimalHelper.multi("-1", str, 6));
      str = getItemValue(b, "settlemoney");
      setItemValue(b, "settlemoney1", 
          DecimalHelper.multi("-1", str, 2));
      getSumdbmodel().fireDatachanged();
    } 
    super.on_retrieved();
  }
  
  protected int on_beforemodify(int paramInt) {
    if (this.mdemodel.getMasterModel().getdbStatus(this.mdemodel.getMasterModel().getRow()) == 3)
      return -1; 
    setFocus("storageopcode");
    return super.on_beforemodify(paramInt);
  }
  
  public void on_doubleclick(int paramInt1, int paramInt2) {
    if (this.mdemodel.getMasterModel().getdbStatus(this.mdemodel.getMasterModel().getRow()) == 3) {
      infoMessage("提示", "总单为删除状态，不允许修改！");
      return;
    } 
    setFocus("storageopcode");
    super.on_doubleclick(paramInt1, paramInt2);
    paramInt2 = this.mdemodel.getMasterModel().getdbStatus(
        this.mdemodel.getMasterModel().getRow());
    int i = this.mdemodel.getDetailModel().getdbStatus(
        this.mdemodel.getDetailModel().getRow());
    SwingUtilities.invokeLater((Runnable)new Object(this, paramInt1, paramInt2, i));
  }
  
  protected int on_beforeNew() {
    if (this.mdemodel.getMasterModel().getdbStatus(this.mdemodel.getMasterModel().getRow()) == 3) {
      infoMessage("提示", "总单为删除状态，不允许新增！");
      return -1;
    } 
    String str;
    if ((str = ((Bms_sales_back_mde)this.mdemodel).getApvalue("是否必须勾原单")).equals("1")) {
      infoMessage("提示", "必须勾原单生成销退！");
      return -1;
    } 
    if (this.mdemodel.getMasterModel().getdbStatus(this.mdemodel.getMasterModel().getRow()) == 3) {
      infoMessage("提示!", "总单为删除状态不能新增细单!");
      return -1;
    } 
    return super.on_beforeNew();
  }
}
